moSetGetVehicles = {};

function moSetGetVehicles:setVehicles(self)
	--if moGeneralSettings.vehicleControlled[3] == nil then moGeneralSettings.vehicleControlled[3] = 0;end;
	--moGeneralSettings.vehicleControlled[3] = moGeneralSettings.vehicleControlled[3]+1;
	--if moGeneralSettings.vehicleControlled[3] < 100 then return;end;
	--moGeneralSettings.vehicleControlled[3] = 0;
	moVehicles = {};
	--for a=1, 6 do --1 tractor,drescher,frontloader,telehandler,wheelloader,rest
		--moVehicles.sort[a] = {};
	--end;
	moGeneralSettings.vehicleControlled[1] = 0;
	if moGeneralSettings.vehicleControlled[2] == nil then
		moGeneralSettings.vehicleControlled[2] = {};
	end;
	local vehiclesLength = table.getn(g_currentMission.steerables);
	--local vehiclesLength = table.getn(g_currentMission.vehicles); 
	if vehiclesLength > 0 then 
		for a=1, vehiclesLength do 
			local vehicle = g_currentMission.steerables[a];			
			moVehicles[a] = {};
			moVehicles[a].object = vehicle;
			moVehicles[a].isControlled = Utils.getNoNil(vehicle.isControlled, false);
			moVehicles[a].hired = Utils.getNoNil(vehicle.isHired, false);			
			local parked = Utils.getNoNil(vehicle.vs_isParked, false);
			if moSetGetGui.pdaVI.seeParked then parked = false;end; 
			if moVehicles[a].isControlled or moVehicles[a].hired or (moSetGetGui.pdaVI.compactDisplay > 0 and not parked) then
				moGeneralSettings.vehicleControlled[1] = moGeneralSettings.vehicleControlled[1]+1
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode] == nil then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode] = {};
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = 0; --3 stufen a 100
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningFuelTank = false;
					--moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningOel = false;
					--moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRepair = false;
				end;
				moVehicles[a].MPOwner = "";
				if vehicle.MPOwner ~= nil then
					moVehicles[a].MPOwner = Utils.getNoNil(vehicle.MPOwner.owner, "");
				end;
				moVehicles[a].area = {};
				moVehicles[a].rootNode = vehicle.rootNode;
				moVehicles[a].isSteerable = Utils.getNoNil(vehicle.isSteerable, false);
				moVehicles[a].name = Utils.getNoNil(vehicle.name, "Unknown");				
				moVehicles[a].isMotorStarted = Utils.getNoNil(vehicle.isMotorStarted, false);			
				moVehicles[a].controllerName = Utils.getNoNil(vehicle.controllerName, "");
				moVehicles[a].controllerNameHired = Utils.getNoNil(vehicle.controllerName, "");
				moVehicles[a].waitingForTrailerToUnload = Utils.getNoNil(vehicle.waitingForTrailerToUnload, false);
				moVehicles[a].vehicleType = Utils.getNoNil(vehicle.typeName, "");
				moVehicles[a].typeDesc = vehicle.typeDesc;
				if string.find(string.lower(moVehicles[a].typeDesc), "missing") or string.find(string.lower(moVehicles[a].typeDesc), "typedescription") then
					moVehicles[a].typeDesc = "unknown"
				end;
				if string.find(string.lower(moVehicles[a].controllerName), "unknown") or not moVehicles[a].isControlled then moVehicles[a].controllerName = "";end;
				if moVehicles[a].vehicleType == "attachableFrontloader" then moVehicles[a].vehicleType = "frontLoader";end;
				moVehicles[a].overlay = "unknown";			
				moVehicles[a].seedsSprayer = false;			
				moVehicles[a].fruitName = "!";
				moVehicles[a].parking = false;
				moVehicles[a].owner = "";
				moVehicles[a].field = 0;
				local foundCollision = false;
				local speed = vehicle.lastSpeed * 3600;
				if not moVehicles[a].isControlled and not moVehicles[a].hired then speed = 0;end;
				moVehicles[a].speed = string.format("%1.0f", "".. Utils.getNoNil(g_i18n:getSpeed(speed), 0));
				if tonumber(speed) <= 1.0 and tonumber(speed) >= 0.001 then --or tonumber(speed) <= moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer+1
					if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer > 1000 then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true;
						foundCollision = true;
					end;
				elseif tonumber(speed) <= 0 or moVehicles[a].waitingForTrailerToUnload then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer+1
					if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer > 1000 then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = true;
					end;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
				end;
				if Utils.getNoNil(vehicle.showWaterWarning, false) then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = true;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = false;
				end;
				moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer+1;
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer > 300 then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = 0;end;
				moVehicles[a].hiredA = false;
				moVehicles[a].hiredC = false;
				moVehicles[a].damageValues = 0;
				moVehicles[a].damage = false;
				moVehicles[a].attached = 0;			
				if vehicle.currentSeed ~= nil then					
					if moFillTypes[vehicle.seeds[vehicle.currentSeed]] ~= nil and moFillTypes[vehicle.seeds[vehicle.currentSeed]].fruitName ~= nil then
						moVehicles[a].fruitName = moFillTypes[vehicle.seeds[vehicle.currentSeed]].fruitName;
					end;
					moVehicles[a].seedsSprayer = true;
				end;
				if string.find(vehicle.typeName, "sprayer") or string.find(vehicle.typeName, "manureBarrel") or string.find(vehicle.typeName, "manureSpreader") then
					moVehicles[a].seedsSprayer = true;
				end;
				local fillType = 0;			
				if vehicle.currentFillType ~= nil then 
					fillType = vehicle.currentFillType; 
				elseif vehicle.currentInputFruitType ~= nil then 
					fillType = vehicle.currentInputFruitType;
					moVehicles[a].seedsSprayer = true;
				end;
				if fillType > 0 then
					local desc = Fillable.fillTypeIndexToDesc[fillType];
					if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
						moVehicles[a].fruitName = moFillTypes[desc.index].fruitName;
					end;					
				end;
				if moVehicles[a].seedsSprayer and vehicle.currentSeed ~= nil then
					local seeds = "";					
					if FruitUtil.fruitTypeToFillType[vehicle.seeds[vehicle.currentSeed]] ~= nil then seeds = FruitUtil.fruitTypeToFillType[vehicle.seeds[vehicle.currentSeed]];end;
					local desc = Fillable.fillTypeIndexToDesc[seeds];
					if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
						seeds = "(".. moFillTypes[desc.index].fruitName.. ")";
					end;
					if string.find(string.lower(seeds), "!") then seeds = "";end;
					local fruitName = moVehicles[a].fruitName;
					if string.find(fruitName, seeds) then seeds = "";end;
					moVehicles[a].fruitName = fruitName.. seeds;
				end;
				if vehicle.capacity ~= nil and vehicle.fillLevel ~= nil and vehicle.fillLevel > 0 then
					moVehicles[a].fillLevel = vehicle.fillLevel;
					moVehicles[a].capacity = vehicle.capacity;
					moVehicles[a].fillLevelProzent = string.format("%1.0f", "".. tonumber(vehicle.fillLevel)/tonumber(vehicle.capacity)*100);
					moVehicles[a].warningCapacityColor = setProzentColor(moVehicles[a].fillLevelProzent, moVehicles[a].seedsSprayer, false);
				end;
				if vehicle.fillLevelMax ~= nil and vehicle.fillLevel ~= nil and vehicle.fillLevel > 0 then
					moVehicles[a].fillLevel = vehicle.fillLevel;
					moVehicles[a].capacity = vehicle.fillLevelMax;
					moVehicles[a].fillLevelProzent = string.format("%1.0f", "".. tonumber(vehicle.fillLevel)/tonumber(vehicle.fillLevelMax)*100);
					moVehicles[a].warningCapacityColor = setProzentColor(moVehicles[a].fillLevelProzent, false, false);
				end;
				if vehicle.fuelCapacity ~= nil and vehicle.fuelFillLevel ~= nil and vehicle.fuelFillLevel > 0 then
					moVehicles[a].fuelFillLevel = vehicle.fuelFillLevel;
					moVehicles[a].fuelCapacity = vehicle.fuelCapacity;
					moVehicles[a].fuelFillLevelProzent = string.format("%1.0f", "".. tonumber(vehicle.fuelFillLevel)/tonumber(vehicle.fuelCapacity)*100);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningFuelTank = setProzentColor(moVehicles[a].fuelFillLevelProzent, false, true);
				end;			
				if moVehicles[a].hired or (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving()) then							 
					moVehicles[a].controllerName = "H ";									
					if vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving() then
						moVehicles[a].hiredC = true;
						moVehicles[a].controllerName = "HC ";
						if vehicle.cp ~= nil and vehicle.cp.wait then
							moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = true;
						else
							moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = false;
						end;
					end;
					if vehicle.numCollidingVehicles ~= nil and not moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait then
						for _,numCollisions in pairs(vehicle.numCollidingVehicles) do
							if numCollisions > 0 then
								foundCollision = true;
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
								break;
							end;
						end;						
						if not foundCollision then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;end;
					end;
					if vehicle.isHirableBlocked and not moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait then							
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
					end;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;
				end;				
				function getField(vehicleField)
					local fieldNumber = 0;
					if vehicleField.components ~= nil and vehicleField.components[1] ~= nil and vehicleField.components[1].node ~= nil then					
						local wx,_,wz = getWorldTranslation(vehicle.components[1].node);
						if wx~=wx or wz~=wz then
							return fieldNumber;
						end;
						if moFieldDef == nil or table.getn(moFieldDef) <= 0 then return fieldNumber;end;
						for fieldNum,fieldDef in ipairs(moFieldDef) do
							for _,tableValues in ipairs(fieldDef) do
								if tableValues.x1 <= wx and wx <= tableValues.x2 and tableValues.z1 <= wz and wz <= tableValues.z2 then									
									local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, wx, wz, tableValues.x1, tableValues.z1, tableValues.x2, tableValues.z2);
									local foundField = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wZ);
									if foundField == nil or foundField <= 0 then break;end;
									fieldNumber = fieldNum;
									break;
								end;
							end;
							if fieldNumber ~= 0 then break;end;
						end;
					end;
					return fieldNumber;
				end;
				local attachedNr = 0;
				function setNextAttached(a, attachedObj)					
					for index,attached in pairs(attachedObj.attachedImplements) do
						if attached ~= nil and attached.object ~= nil then															
							setAttached(a, attached.object);
							break;							
						end;							
					end;
				end;
				function setAttached(a, attachedObj)				
					attachedNr = attachedNr+1					
					moVehicles[a].attached = moVehicles[a].attached+1
					moVehicles[a].attachedValues[attachedNr] = {};
					moVehicles[a].attachedValues[attachedNr].vehicleType = Utils.getNoNil(attachedObj.typeName, "unknown");
					moVehicles[a].attachedValues[attachedNr].name = Utils.getNoNil(attachedObj.name, "unknown");					
					moVehicles[a].attachedValues[attachedNr].typeDesc = Utils.getNoNil(attachedObj.typeDesc, "unknown");
					moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(attachedObj.fillLevel, nil);
					moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(attachedObj.capacity, nil);
					if string.find(string.lower(moVehicles[a].attachedValues[attachedNr].typeDesc), "missing") or string.find(string.lower(moVehicles[a].attachedValues[attachedNr].typeDesc), "typedescription") then
						moVehicles[a].attachedValues[attachedNr].typeDesc = "unknown"
					end;
					moVehicles[a].attachedValues[attachedNr].fruitName = "!";
					moVehicles[a].attachedValues[attachedNr].seedsSprayer = false;
					fillType = 0;
					local extraFillType = false;
					if moVehicles[a].attachedValues[attachedNr].vehicleType == "attachableFrontloader" then moVehicles[a].vehicleType = "frontLoader";end;
					if moVehicles[a].attachedValues[attachedNr].vehicleType == "dynamicMountAttacherImplement" then
						if attachedObj.dynamicMountedObjects ~= nil then --dynamicMountedObjects, aiRequiredFruitType, aiProhibitedFruitType components, schemaOverlay							
							for k, v in pairs(attachedObj.dynamicMountedObjects) do 
								if k ~= nil then									
									extraFillType = true;
									fillType = Utils.getNoNil(k.fillType, 0); --aiRequiredFruitType, aiProhibitedFruitType, isAddedToMission
									moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(k.fillLevel, nil);
									moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(k.capacity, nil);
									if k.fillablePalletDirtyFlag ~= nil then moVehicles[a].attachedValues[attachedNr].typeDesc = "Pallete";end;
									if k.baleMesh ~= nil then 
										moVehicles[a].attachedValues[attachedNr].typeDesc = "Bale";
										moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(k.fillLevel, nil);
									end; --physicsObjectDirtyFlag									
									break;																									
								end;
							end;
						end												
					end;
					if attachedObj.currentSeed ~= nil then						
						if moFillTypes[attachedObj.seeds[attachedObj.currentSeed]] ~= nil and moFillTypes[attachedObj.seeds[attachedObj.currentSeed]].fruitName ~= nil then
							moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[attachedObj.seeds[attachedObj.currentSeed]].fruitName;
						end;
						moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;
					end;
					if string.find(attachedObj.typeName, "sprayer") or string.find(attachedObj.typeName, "manureBarrel") or string.find(attachedObj.typeName, "manureSpreader") and not string.find(attachedObj.typeName, "manureBarrelCultivator") then
						moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;						
					end;
					local foundFill = false;					
					if not extraFillType then
						if attachedObj.currentFillType ~= nil then 
							fillType = attachedObj.currentFillType; 
						elseif attachedObj.currentInputFruitType ~= nil then 
							fillType = attachedObj.currentInputFruitType;
							moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;					
						end;
					end;
					if attachedObj.currentBalePlace ~= nil then
						fillType = attachedObj.currentBalePlace;
					end;
					if attachedObj.currentPallet ~= nil then
						fillType = attachedObj.currentPallet;
					end;
					
					if fillType > 0 then
						local desc = Fillable.fillTypeIndexToDesc[fillType];					
						if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
							moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[desc.index].fruitName;
						end;					
					end;
					if moVehicles[a].attachedValues[attachedNr].seedsSprayer and attachedObj.currentSeed ~= nil then
						local seeds = "";
						if FruitUtil.fruitTypeToFillType[attachedObj.seeds[attachedObj.currentSeed]] ~= nil then seeds = FruitUtil.fruitTypeToFillType[attachedObj.seeds[attachedObj.currentSeed]];end;
						local desc = Fillable.fillTypeIndexToDesc[seeds];
						if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
							seeds = "(".. moFillTypes[desc.index].fruitName.. ")";
						end;
						if string.find(string.lower(seeds), "unknown") then seeds = "";end;
						local fruitName = moVehicles[a].attachedValues[attachedNr].fruitName;
						if string.find(fruitName, seeds) then seeds = "";end;
						moVehicles[a].attachedValues[attachedNr].fruitName = fruitName.. seeds;
					end;
					if moVehicles[a].attachedValues[attachedNr].fillLevel ~= nil and moVehicles[a].attachedValues[attachedNr].capacity ~= nil then						
						foundFill = true;
						local fillLevel = moVehicles[a].attachedValues[attachedNr].fillLevel;
						local capacity = moVehicles[a].attachedValues[attachedNr].capacity;
						moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(fillLevel)/tonumber(capacity)*100);
						moVehicles[a].attachedValues[attachedNr].warningCapacityColor = setProzentColor(moVehicles[a].attachedValues[attachedNr].fillLevelProzent, moVehicles[a].attachedValues[attachedNr].seedsSprayer, false);
					end;
					if attachedObj.fillLevelMax ~= nil and attachedObj.fillLevel ~= nil then
						foundFill = true;
						moVehicles[a].attachedValues[attachedNr].fillLevel = attachedObj.fillLevel;
						moVehicles[a].attachedValues[attachedNr].capacity = attachedObj.fillLevelMax;
						moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(attachedObj.fillLevel)/tonumber(attachedObj.fillLevelMax)*100);
						moVehicles[a].attachedValues[attachedNr].warningCapacityColor = setProzentColor(moVehicles[a].attachedValues[attachedNr].fillLevelProzent, false, false);
					end;									
					if attachedObj.attachedImplements ~= nil and attachedNr <= 5 then
						setNextAttached(a, attachedObj);						
					end;					
				end;				
				if vehicle.attachedImplements then					
					moVehicles[a].attachedValues = {};
					for index,attached in pairs(vehicle.attachedImplements) do
						if attached ~= nil and attached.object ~= nil then							
							setAttached(a, attached.object)
						end;						
					end;
				end;
				if moVehicles[a].isSteerable and moSetGetGui.pdaVI.fieldDisplay then moVehicles[a].field = getField(vehicle);end;
				--if string.find(moVehicles[a].vehicleType, "combine_animated") or string.find(moVehicles[a].vehicleType, "selfPropelledPotatoHarvester") and a ~= 1 then
				--	local noticeVehicle = moVehicles[a];
				--	table.remove(moVehicles[a]);
				--	table.insert(moVehicles, 1, noticeVehicle)
				--end;				
			else
				table.remove(moVehicles[a])
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode] ~= nil then table.remove(moGeneralSettings.vehicleControlled[2][vehicle.rootNode]);end;
			end;			
		end;		
	end;	
end;

function setProzentColor(fillProzent, reverse, fuel)	
	local ratio = tonumber(fillProzent);
	if fuel then
		if tonumber(ratio) < 10 then return true;end;
		return false;
	end;
	if tonumber(ratio) >= 90 then
		if reverse then return moSetGetGui.pdaVI.warningColor0;end;
		return moSetGetGui.pdaVI.warningColor4;
	elseif tonumber(ratio) < 90 and tonumber(ratio) >= 75 then
		if reverse then return moSetGetGui.pdaVI.warningColor1;end;
		return moSetGetGui.pdaVI.warningColor3;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		return moSetGetGui.pdaVI.warningColor2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 15 then
		if reverse then return moSetGetGui.pdaVI.warningColor3;end;
		return moSetGetGui.pdaVI.warningColor1;
	elseif tonumber(ratio) < 15 then
		if reverse then return moSetGetGui.pdaVI.warningColor4;end;
		return moSetGetGui.pdaVI.warningColor0;
	end;	
end;
