moMenueXmlCfg = {};

function moMenueXmlCfg:setMouse(self, posX, posY, isDown, isUp, button)	
	if button == Input.MOUSE_BUTTON_LEFT and isDown then		
		if not moSetGetGui.dragDropPos then	
			if MultiOverlayV2:mouseIsInArea(posX, posY, unpack(moMouseClickAreas.xmlCfg["save"]))then			
				if not moSetGetGui.cfgMenue.saveXml then
					MultiOverlayV2:saveSettings(self, "clientSettings");			
					moSetGetGui.cfgMenue.saveXml = true;
				end;
				return;
			end;		
			for a=1, 8 do		
				if MultiOverlayV2:mouseIsInArea(posX, posY, unpack(moMouseClickAreas.xmlCfg[a])) then
					if setXmlCfgValues(self, a) then moSetGetGui.cfgMenue.saveXml = false;end;
					break;
				end;
			end;
		end;
	end;
end;

function setXmlCfgValues(self, a)	 
	if a == 1 then
		if moGeneralSettings.fruitsDoubleNames then
			moGeneralSettings.fruitsDoubleNames = false;			
		else
			moGeneralSettings.fruitsDoubleNames = true;
		end;
		return true;
	end;
	if a == 2 then
		MultiOverlayV2.timerUpdate.interval = MultiOverlayV2.timerUpdate.interval+28125;
		if MultiOverlayV2.timerUpdate.interval > 1800000 then
			MultiOverlayV2.timerUpdate.interval = 2000;
		end;
		setTimerTime(MultiOverlayV2.timerUpdate.id, MultiOverlayV2.timerUpdate.interval);
		return true;
	end;
	if a == 3 then
		if moSetGetGui.screenAspectRatioAuto then
			moSetGetGui.screenAspectRatioAuto = false;
		else
			moSetGetGui.screenAspectRatioAuto = true;
			moGuiExtras:setScreenAspectRatio(self);
		end;
		return true;
	end;
	if a == 4 and not moSetGetGui.screenAspectRatioAuto then
		moSetGetGui.screenAspectRatio = moSetGetGui.screenAspectRatio+0.5
		if moSetGetGui.screenAspectRatio > 10 then
			moSetGetGui.screenAspectRatio = 0.0;
		end;
		return true;
	end;
	if a == 5 and not moGeneralSettings.saveGameClientSettings then
		moXmlSettings:generateSavegameXml(self, "clientSettings");
	end;
	if a == 6 and not moGeneralSettings.saveGameObjectSettings then
		moXmlSettings:generateSavegameXml(self, "objectSettings");
	end;
	if a == 7 and not moGeneralSettings.saveGameLanguage then
		moXmlSettings:generateSavegameXml(self, "language");
	end;
	if a == 8 then
		if moGuiMiniPdaSlots.separatedAmount then
			moGuiMiniPdaSlots.separatedAmount = false;
		else
			moGuiMiniPdaSlots.separatedAmount = true;
		end;
		return true;
	end;
	return false;
end;